// DetailTypeDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailTypeDlg.h"
#include "afxdialogex.h"


// CDetailTypeDlg _CAO

IMPLEMENT_DYNAMIC(CDetailTypeDlg, CDialog)

CDetailTypeDlg::CDetailTypeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDetailTypeDlg::IDD, pParent)
{

}

CDetailTypeDlg::~CDetailTypeDlg()
{
}

void CDetailTypeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_LOOP, m_xcCheckLoop);
	DDX_Control(pDX, IDC_CHECK_INIT, m_xcCheckInit);
	DDX_Control(pDX, IDC_EDIT_OFFSET, m_xcEditOffset);
	DDX_Control(pDX, IDC_SPIN_OFFSET, m_xcSpinOffset);
	DDX_Control(pDX, IDC_CHECK_DELAY, m_xcCheckDelay);
	DDX_Control(pDX, IDC_EDIT_BUFFER, m_xcEditBuffer);
	DDX_Control(pDX, IDC_SPIN_BUFFER, m_xcSpinBuffer);
	DDX_Control(pDX, IDC_CHECK_TIMESTAMP, m_xcCheckTimestamp);
}

void CDetailTypeDlg::InitControls()
{
	m_xcCheckLoop.SetCheck(type_.flv.loop ? BST_CHECKED : BST_UNCHECKED);

	m_xcCheckInit.SetCheck(type_.flv.init ? BST_CHECKED : BST_UNCHECKED);
	m_xcSpinOffset.SetPos32(type_.flv.offset);

	m_xcEditOffset.EnableWindow(type_.flv.init ? TRUE : FALSE);
	m_xcSpinOffset.EnableWindow(type_.flv.init ? TRUE : FALSE);

	m_xcCheckDelay.SetCheck(type_.flv.delay ? BST_CHECKED : BST_UNCHECKED);
	m_xcSpinBuffer.SetPos32(type_.flv.buffer);

	m_xcEditBuffer.EnableWindow(type_.flv.delay ? TRUE : FALSE);
	m_xcSpinBuffer.EnableWindow(type_.flv.delay ? TRUE : FALSE);

	m_xcCheckTimestamp.SetCheck(type_.flv.timestamp ? BST_CHECKED : BST_UNCHECKED);
}


BEGIN_MESSAGE_MAP(CDetailTypeDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailTypeDlg::OnBnClickedBtnAllDefault)
	ON_BN_CLICKED(IDC_CHECK_INIT, &CDetailTypeDlg::OnBnClickedCheckInit)
	ON_BN_CLICKED(IDC_CHECK_DELAY, &CDetailTypeDlg::OnBnClickedCheckDelay)
END_MESSAGE_MAP()


// CDetailTypeDlg bZ[W nh[


BOOL CDetailTypeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcSpinOffset.SetRange32(0, 60000);
	m_xcSpinBuffer.SetRange32(0, 60000);

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailTypeDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailTypeDlg::OnDestroy()
{
	CDialog::OnDestroy();

	type_.flv.loop = m_xcCheckLoop.GetCheck() == BST_CHECKED;
	type_.flv.delay = m_xcCheckInit.GetCheck() == BST_CHECKED;
	type_.flv.offset = m_xcSpinOffset.GetPos32();
	type_.flv.delay = m_xcCheckDelay.GetCheck() == BST_CHECKED;
	type_.flv.buffer = m_xcSpinBuffer.GetPos32();
	type_.flv.timestamp = m_xcCheckTimestamp.GetCheck() == BST_CHECKED;
}


void CDetailTypeDlg::OnBnClickedBtnAllDefault()
{
	type_ = sl::TypeConfig();
	InitControls();
}

void CDetailTypeDlg::OnBnClickedCheckInit()
{
	type_.flv.init = m_xcCheckInit.GetCheck() == BST_CHECKED;

	m_xcCheckInit.SetCheck(type_.flv.init ? BST_CHECKED : BST_UNCHECKED);

	m_xcEditOffset.EnableWindow(type_.flv.init ? TRUE : FALSE);
	m_xcSpinOffset.EnableWindow(type_.flv.init ? TRUE : FALSE);
}

void CDetailTypeDlg::OnBnClickedCheckDelay()
{
	type_.flv.delay = m_xcCheckDelay.GetCheck() == BST_CHECKED;

	m_xcCheckDelay.SetCheck(type_.flv.delay ? BST_CHECKED : BST_UNCHECKED);

	m_xcEditBuffer.EnableWindow(type_.flv.delay ? TRUE : FALSE);
	m_xcSpinBuffer.EnableWindow(type_.flv.delay ? TRUE : FALSE);
}
