#include "stdafx.h"

#pragma warning(disable : 4503)

// O[of[^{
gl::GlobalValues gl_;
sl::SerializeValues sl_;

namespace gl {

void GlobalValues::getAspect(SIZE& aspect)
{
	aspect.cx = 0;
	aspect.cy = 0;
	if  (value.window.aspect == sl::WINDOW_ASPECT_DEFAULT)
	{
		player.getNativeVideoSize(aspect);
	}
	else if (value.window.aspect == sl::WINDOW_ASPECT_NONE)
	{
		aspect.cx = 0;
		aspect.cy = 0;
	}
	else
	{
		int i = value.window.aspect - sl::WINDOW_ASPECT_CUSTOM;

		try {
			sl::WindowAspect x = value.display.window.aspect.at(i);
			aspect.cx = x.ax;
			aspect.cy = x.ay;
		} catch(...) {}
	}
}

}
